#include <linux/prctl.h>
#include <stdio.h>
#include <linux/signal.h>
#include <string.h>

typedef unsigned char UBYTE;
typedef long BYTE4;
typedef unsigned long OBJECT_NAME;
typedef struct Queue_pbox{
	UBYTE  *data;		/* ǡؤΥݥ */
	BYTE4  size;		/* ǡΥ */
	BYTE4  timeout;		/* ॢȤλ */
	OBJECT_NAME sender;	/* ǡ̾ */
	BYTE4  when;		/* 礬ǡ򥭥塼󥰤Υƥ */
} QUEUE_PBOX;

#define NAME_UNIQUE -1
#define MKNAME(a,b,c,d) ((((a)<<24)&0xff000000) |(((b)<<16)&0x00ff0000) | \
			 (((c)<< 8)&0x0000ff00) |(((d)    )&0x000000ff))

char* make_path(char*                                                                                  path)
{
	static char buf[300];
	buf[299] = 0;

	if (*path == '/'){
		return strcpy (buf, path);
	} else {
		strcpy(buf, "/sbin/");
		strcpy(buf+6, path);
		return buf;
	}
}

int main(int argc, char* argv[], char* envp[])
{
	int pid;
	OBJECT_NAME queue;
	char* path;

	if (argc < 2){
		printf("Usage: %s command args...\n", argv[0]);
		exit(1);
	}

#if 0
	queue = name_generate();
	if (queue_create(queue, 1, 4) == -1){
		printf("queue_create: Failed\n");
		exit(1);
	}
#else
	queue = MKNAME('g', 'd', 'b', 'q');
	printf ("queue = %x\n", queue);
#endif

	path = make_path(argv[1]);
	printf ("target program = %s\n", path);

	if ((pid = fork()) < 0){
		perror("fork");
		exit (1);
	}

	if (pid == 0){
		if (prctl(PR_SET_EXECNOTIFY, queue) < 0){
			perror("prctl");
			exit(1);
		}
		execve (path, argv+1, envp);
		perror("execve");
		exit(1);
	} else {
#if 0
		QUEUE_PBOX qpb;
		OBJECT_NAME procname;
		int ret;
		int scratch;
		qpb.data = &procname;
		qpb.size = 4;
		qpb.timeout = 60*60; /* 1 min */
		if ((ret = queue_read(queue, &qpb)) == -1){
			printf("queue_read: Failed\n");
			kill (SIGKILL, pid);
			exit (1);
		} else if (ret == -2) {
			printf("queue_read: Timeout\n");
			kill (SIGKILL, pid);
			exit(1);
		}
		printf ("new proc generated : pid = %d procname = %08X\n", pid, procname);
		printf ("starting...");
		ret = proc_start(procname);
		printf ("done (%d)\n", ret);
#else
		int scratch;
		waitpid(pid, &scratch, 0);
#endif
	}

	return 0;
}


		
