
#ifndef _STDIO_H_
#define _STDIO_H_

#include <sys/cdefs.h>

#define __need_NULL
#include <stddef.h>

#define BUFSIZ	1024

typedef struct _FILE
  {
    int _fd;
    unsigned int _flags;
  }
FILE;

#define _SIO_RDOK	(1U << 0)
#define _SIO_WROK	(1U << 1)
#define _SIO_LBUF	(1U << 2)
#define _SIO_FBUF	(1U << 3)

extern FILE __iob[];
#define stdin	(&__iob[0])
#define stdout	(&__iob[1])
#define stderr	(&__iob[2])

extern int printf (const char *__fmt, ...)
	__attribute__ ((__format__ (__printf__, 1, 2)));

extern int fprintf __P ((FILE *__fp, __const char *__fmt, ...))
	__attribute__ ((__format__ (__printf__, 2, 3)));
#ifdef __GNUC_VA_LIST
extern int vfprintf __P ((FILE *__fp, const char *__fmt,
			  __gnuc_va_list __args))
	__attribute__ ((__format__ (__printf__, 2, 0)));
#endif

extern int fdprintf (int __fd, const char *__fmt, ...)
	__attribute__ ((__format__ (__printf__, 2, 3)));
#ifdef __GNUC_VA_LIST
extern int vfdprintf (int __fd, const char *__fmt, __gnuc_va_list __args)
	__attribute__ ((__format__ (__printf__, 2, 0)));
#endif

extern void perror (const char *);

extern int sys_nerr;
extern const char *const sys_errlist[];

#ifndef SEEK_SET
# define SEEK_SET	0
# define SEEK_CUR	1
# define SEEK_END	2
#endif

#endif
