#ifndef _ZX_STDLIB_H_
#define _ZX_STDLIB_H_

#include <sys/cdefs.h>
#include <sys/types.h>

#define __need_NULL
#include <stddef.h>

extern unsigned long strtoul __P ((__const char *__str, char **__endp,
				   int __base));
extern long strtol __P ((__const char *__str, char **__endp, int __base));

extern void abort __P ((void)) __attribute__ ((__noreturn__));

extern char *getenv __P ((__const char *__name));

extern void *malloc __P ((size_t));
extern void *calloc __P ((size_t, size_t));

extern void *bsearch __P ((__const void *__key, __const void *__base,
			   size_t __nmemb, size_t __size,
			   int (*__compar) (__const void *, __const void *)));
extern void qsort __P ((__const void *__base, size_t __nmemb, size_t __size,
			int (*__compar) (__const void *, __const void *)));

void free __P ((void *));
#define cfree(ptr)	free (ptr)

extern __inline__ int
atoi (__const char *__str)
{
  return strtol (__str, NULL, 10);
}

#endif
