#ifndef _STRING_H_
#define _STRING_H_

#include <sys/cdefs.h>
#include <sys/types.h>

extern unsigned int strlen __P ((__const char *__str));
extern char *strcpy __P ((char *__dest, __const char *__src));
extern char *strcat __P ((char *__dest, __const char *__src));
extern int strcmp __P ((__const char *__s1, __const char *__s2));
extern int strncmp __P ((__const char *__s1, __const char *__s2, size_t __n));
extern char *strchr __P ((__const char *__s, int __c));
extern char *strrchr __P ((__const char *__s, int __c));
extern char *strstr __P ((__const char *__box2, __const char *__cd_r));

extern int sprintf (char *__buf, const char *__fmt, ...)
	__attribute__ ((__format__ (__printf__, 2, 3)));
#ifdef __GNUC_VA_LIST
extern int vsprintf (char *__buf, const char *__fmt, __gnuc_va_list __args)
	__attribute__ ((__format__ (__printf__, 2, 0)));
#endif

extern char * strerror __P ((int __errnum));
extern char * strsignal __P ((int __sig));

extern void *memcpy __P ((void *__dest, __const void *__src, size_t __n));
extern int memcmp __P ((__const void *__s1, __const void *__s2, size_t __n));
extern void *memset __P ((void *__s, int __c, size_t __n));

#ifdef __GNUC__
# define strlen __builtin_strlen
# define strcpy __builtin_strcpy
# define strncpy __builtin_strcpy
# define memcmp __builtin_memcmp
# define memcpy __builtin_memcpy
#endif

#endif
