#ifndef _ZX_SYS_WAIT_H_
#define _ZX_SYS_WAIT_H_

#include <sys/types.h>
#include <sys/cdefs.h>

extern pid_t wait __P ((int *__status));
extern pid_t waitpid __P ((pid_t __pid, int *__status, int __options));

struct rusage;
extern pid_t wait4 __P ((pid_t __pid, int *__status, int __options,
			 struct rusage *__rusage));
extern pid_t wait3 __P ((int *__status, int __options,
			 struct rusage *__rusage));

#ifdef __GNUC__
extern __inline__ pid_t wait3 __P ((int *__status, int __options,
				    struct rusage *__rusage))
{
  return wait4 (-1, __status, __options, __rusage);
}
#endif

#include <linux/wait.h>

#define WEXITSTATUS(status)	(((status) & 0xff00) >> 8)
#define WTERMSIG(status)	((status) & 0x7f)
#define WSTOPSIG(status)	WEXITSTATUS (status)
#define WIFEXITED(status)	(WTERMSIG (status) == 0)
#define WIFSTOPPED(status)	(((status) & 0xff) == 0x7f)
#define WCOREDUMP(status)	(((status) & __WCOREFLAG) != 0)
#define WIFSIGNALED(status)	(!WIFSTOPPED (status) && !WIFEXITED (status))

#define __WCOREFLAG	0x80

#endif
