#include <stdarg.h>
#include "string.h"

int vfdprintf (int fd, const char *fmt, va_list ap)
{
	char buf[1024];
	int count, total_written, written;

	count = vsprintf (buf, fmt, ap);
	for (total_written = 0;
	     count > 0;
	     total_written += written, count -= written) {
		written = write (fd, buf + total_written, count);
		if (written < 0)
			break;
	}
	return total_written;
}
